<template>
  <div class="signin">
    <form class="form">
      <h1>Đăng Nhập</h1>
      <div class="text_field">
        <input type="text" class="text_input" placeholder=" " v-model="username">
        <label class="text_label">Tên đăng nhập</label>
      </div>
      <div class="text_field">
        <input type="password" class="text_input" placeholder=" " v-model="password">
        <label class="text_label">Mật khẩu</label>
      </div>
      <div class="forget">Quên mật khẩu?</div>
      <button type="submit" @click.stop.prevent="signIn()">Đăng nhập</button>
      <div class="signup-link">Không có tài khoản?         
        <router-link :to='{name:"Register", query: {link: link}}'>Đăng ký</router-link>
      </div>
    </form>
  </div>
</template>
  
<script>
import UserService from "../services/UserService"

export default {
  name: 'login-page',  
  data() {
    return{      
      loading: false,
      username: '',
      password: '',
      link: this.$route.query.link,
    }
  },
  methods:{
    async signIn(){
      if(this.loading) return
      this.loading = true

      try{
        let response = await UserService.logIn({ 
          username: this.username, 
          password: this.password 
        })
        console.log(response)
        if(response.status == 200){
          this.$store.dispatch('logIn', response.data)
          if(!this.link) this.$router.push({ name: 'Home'})
          else this.$router.push({ path: this.link })
        }
        else {          
          alert(response.statusText)
        }        
      }
      catch(err){        
        console.log(err)
        alert('Login Failed')
      }
      finally{
        this.loading = false
      }
    },
  }
}
</script>

<style scoped>
.signin{
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  justify-content: center;
  align-items: center;
}

.form{
  width: 360px;
  padding: 2rem;
  border-radius: 1rem;
  box-shadow: 0 10px 25px #ccc;
}

h1{
  text-align: center;
  font-weight: bold;
  margin-bottom: 3rem;
}

.text_field{
  height: 48px;
  width: 100%;  
  margin-bottom: 16px;
  border-bottom: 2px solid #666;
  display:flex 
}

.text_input{
  position: inherit;
  width: 100%;
  height: 100%;
  border: none;
  outline: none;
  background: none;
  z-index: 1; 
  font-size: 16px;
}


.text_label{
  position: absolute;
  transform: translate(0px,22px);
  background-color: #fff;
  color: black;
  font-size: 16px;
  transition: .3s;
  z-index: 2;
}

button{
  margin: 46px 0px;
  width: 100%;
  height: 48px;
  border-radius: 24px;
  font-weight: bold;
  font-size: 18px;
  outline: none;
  border: 1px solid #666;
} 


.text_input:focus + .text_label{
  transform: translateY(-2px);
  font-size: 12px;
  font-weight: 500;
}

.text_input:not(:placeholder-shown).text_input:not(:focus)+ .text_label{
  transform: translateY(-2px);
  font-size: 12px;
  font-weight: 500;
}

button:hover{
  border-width: 2px;
  border-color: #333;
  transform: 0.2s;
  cursor: pointer;
} 

.forget{
  text-align: end;
  margin-top: 16px;
}

.signup-link{
  text-align: center;
}
</style>